Package com.google.javascript.rhino.jstype

# Class EnumType

java.lang.Object
com.google.javascript.rhino.jstype.JSType
com.google.javascript.rhino.jstype.ObjectType
com.google.javascript.rhino.jstype.EnumType

All Implemented Interfaces:
  `StaticScope<JSType>`, `Serializable`

public class EnumType extends ObjectType
An enum type representing a branded collection of elements. Each element is referenced by its name, and has an `EnumElementType` type.

See Also:
  - Serialized Form

## Nested Class Summary

## Nested classes/interfaces inherited from class com.google.javascript.rhino.jstype.JSType

`JSType.TypePair`

## Field Summary

### Fields inherited from class com.google.javascript.rhino.jstype.JSType

`EMPTY_TYPE_COMPONENT, ENUMDECL, NOT_A_CLASS, NOT_A_TYPE, NOT_ENUMDECL, templateTypeMap, UNKNOWN_NAME`

## Method Summary

Modifier and Type
Method
Description
`boolean`
`canBeCalled()`
This predicate is used to test whether a given type can be used as the 'function' in a function call.
`boolean`
`defineElement(String name, Node definingNode)`
Defines a new element on this enum.
`FunctionType`
`getConstructor()`
Gets this object's constructor.
`Iterable<ObjectType>`
`getCtorExtendedInterfaces()`
Gets the interfaces extended by the interface associated with this type.
`Iterable<ObjectType>`
`getCtorImplementedInterfaces()`
Gets the interfaces implemented by the ctor associated with this type.
`String`
`getDisplayName()`
Returns a user meaningful label for the JSType instance.
`Set<String>`
`getElements()`
Gets the elements defined on this enum.
`EnumElementType`
`getElementsType()`
Gets the elements' type.
`ObjectType`
`getImplicitPrototype()`
Gets the implicit prototype (a.k.a.
`FunctionType`
`getOwnerFunction()`
Gets the owner of this if it's a function prototype.
`String`
`getReferenceName()`
Gets the reference name for this object.
`Node`
`getSource()`
Gets the source node or null if this is an unknown enum.
`boolean`
`hasCachedValues()`
Returns true if any cached values have been set for this type.
`boolean`
`hasReferenceName()`
Returns true if the object is named.
`boolean`
`isNativeObjectType()`
Whether this is a built-in object.
`boolean`
`isSubtype(JSType that)`
Checks whether `this` is a subtype of `that`.
`void`
`matchConstraint(JSType constraint)`
Modify this type so that it matches the specified type.
`boolean`
`matchesNumberContext()`
This predicate is used to test whether a given type can appear in a numeric context, such as an operand of a multiply operator.
`boolean`
`matchesObjectContext()`
This predicate is used to test whether a given type can appear in an `Object` context, such as the expression in a with statement.
`boolean`
`matchesStringContext()`
This predicate is used to test whether a given type can appear in a `String` context, such as an operand of a string concat (+) operator.
`void`
`matchRecordTypeConstraint(ObjectType constraintObj)`
`boolean`
`removeProperty(String name)`
Removes the declared or inferred property from this ObjectType.
`void`
`setPropertyJSDocInfo(String propertyName, JSDocInfo info)`
Sets the docInfo for the specified property from the `JSDocInfo` on its definition.
`TernaryValue`
`testForEquality(JSType that)`
Compares `this` and `that`.
`EnumType`
`toMaybeEnumType()`
Downcasts this to an EnumType, or returns null if this is not an EnumType.
`JSType`
`unboxesTo()`
Turn an object type to its corresponding scalar type.
`<T> T`
`visit(Visitor<T> visitor)`
Visit this type with the given visitor.

### Methods inherited from class com.google.javascript.rhino.jstype.ObjectType

`cast, clearCachedValues, createDelegateSuffix, defineDeclaredProperty, defineInferredProperty, defineSynthesizedProperty, findPropertyType, getJSDocInfo, getNormalizedReferenceName, getOwnPropertyJSDocInfo, getOwnPropertyNames, getOwnSlot, getParentScope, getPossibleToBooleanOutcomes, getPropertiesCount, getPropertyNames, getPropertyNode, getPropertyType, getRootNode, getSlot, getTemplateTypes, getTypeOfThis, hasOwnProperty, hasProperty, isFunctionPrototypeType, isObject, isPropertyInExterns, isPropertyTypeDeclared, isPropertyTypeInferred, isUnknownType, setJSDocInfo`

### Methods inherited from class com.google.javascript.rhino.jstype.JSType

`autobox, autoboxesTo, canCastTo, canTestForEqualityWith, canTestForShallowEqualityWith, clearResolved, collapseUnion, dereference, differsFrom, equals, forceResolve, getGreatestSubtype, getLeastSupertype, getRestrictedTypeGivenToBooleanOutcome, getTemplateTypeMap, getTypesUnderEquality, getTypesUnderInequality, getTypesUnderShallowEquality, getTypesUnderShallowInequality, hasAnyTemplateTypes, hasDisplayName, hashCode, isAllType, isArrayType, isBooleanObjectType, isBooleanValueType, isCheckedUnknownType, isConstructor, isDateType, isDict, isEmptyType, isEnumElementType, isEnumType, isEquivalent, isEquivalentTo, isFunctionType, isGlobalThisType, isInstanceType, isInterface, isInvariant, isNominalConstructor, isNominalType, isNoObjectType, isNoResolvedType, isNoType, isNullable, isNullType, isNumber, isNumberObjectType, isNumberValueType, isOrdinaryFunction, isRecordType, isRegexpType, isResolved, isString, isStringObjectType, isStringValueType, isStruct, isTemplateType, isTemplatizedType, isUnionType, isVoidType, matchesInt32Context, matchesUint32Context, resolve, restrictByNotNullOrUndefined, setValidator, toAnnotationString, toDebugHashCodeString, toMaybeEnumElementType, toMaybeFunctionType, toMaybeFunctionType, toMaybeTemplateType, toMaybeTemplateType, toMaybeTemplatizedType, toMaybeTemplatizedType, toMaybeUnionType, toObjectType, toString`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

## Method Details

### getSource

public Node getSource()
Gets the source node or null if this is an unknown enum.

### toMaybeEnumType

public EnumType toMaybeEnumType()
Description copied from class: `JSType`
Downcasts this to an EnumType, or returns null if this is not an EnumType.

Overrides:
  `toMaybeEnumType` in class `JSType`

### getImplicitPrototype

public ObjectType getImplicitPrototype()
Description copied from class: `ObjectType`
Gets the implicit prototype (a.k.a. the `[[Prototype]]` property).

### getElements

public Set<String> getElements()
Gets the elements defined on this enum.

Returns:
  the elements' names defined on this enum. The returned set is immutable.

### defineElement

public boolean defineElement(String name, Node definingNode)
Defines a new element on this enum.

Parameters:
  `name` - the name of the new element
  `definingNode` - the `Node` that defines this new element
Returns:
  true iff the new element is added successfully

### getElementsType

public EnumElementType getElementsType()
Gets the elements' type.

### testForEquality

public TernaryValue testForEquality(JSType that)
Description copied from class: `JSType`
Compares `this` and `that`.

Overrides:
  `testForEquality` in class `ObjectType`
Returns:
  - `TernaryValue.TRUE` if the comparison of values of `this` type and `that` always succeed (such as `undefined` compared to `null`)
  - `TernaryValue.FALSE` if the comparison of values of `this` type and `that` always fails (such as `undefined` compared to `number`)
  - `TernaryValue.UNKNOWN` if the comparison can succeed or fail depending on the concrete values

### isSubtype

public boolean isSubtype(JSType that)
Description copied from class: `JSType`
Checks whether `this` is a subtype of `that`.

Subtyping rules:

- (unknown) — every type is a subtype of the Unknown type.
- (no) — the No type is a subtype of every type.
- (no-object) — the NoObject type is a subtype of every object type (i.e. subtypes of the Object type).
- (ref) — a type is a subtype of itself.
- (union-l) — A union type is a subtype of a type U if all the union type's constituents are a subtype of U. Formally
  `(T<sub>1</sub>, &hellip;, T<sub>n</sub>) &lt;: U` if and only `T<sub>k</sub> &lt;: U` for all `k &isin; 1..n`.
- (union-r) — A type U is a subtype of a union type if it is a subtype of one of the union type's constituents. Formally
  `U &lt;: (T<sub>1</sub>, &hellip;, T<sub>n</sub>)` if and only if `U &lt;: T<sub>k</sub>` for some index `k`.
- (objects) — an Object `O<sub>1</sub>` is a subtype of an object `O<sub>2</sub>` if it has more properties than `O<sub>2</sub>` and all common properties are pairwise subtypes.

Returns:
  `this &lt;: that`

### getDisplayName

public String getDisplayName()
Description copied from class: `JSType`
Returns a user meaningful label for the JSType instance. For example, Functions and Enums will return their declaration name (if they have one). Some types will not have a meaningful display name. Calls to hasDisplayName() will return true IFF getDisplayName() will return null or a zero length string.

Overrides:
  `getDisplayName` in class `ObjectType`
Returns:
  the display name of the type, or null if one is not available

### visit

public <T> T visit(Visitor<T> visitor)
Description copied from class: `JSType`
Visit this type with the given visitor.

Overrides:
  `visit` in class `ObjectType`
Returns:
  the value returned by the visitor
See Also:
  - `Visitor`

### getConstructor

public FunctionType getConstructor()
Description copied from class: `ObjectType`
Gets this object's constructor.

Returns:
  this object's constructor or `null` if it is a native object (constructed natively v.s. by instantiation of a function)

### matchesNumberContext

public boolean matchesNumberContext()
Description copied from class: `JSType`
This predicate is used to test whether a given type can appear in a numeric context, such as an operand of a multiply operator.

### matchesStringContext

public boolean matchesStringContext()
Description copied from class: `JSType`
This predicate is used to test whether a given type can appear in a `String` context, such as an operand of a string concat (+) operator. All types have at least the potential for converting to `String`. When we add externally defined types, such as a browser OM, we may choose to add types that do not automatically convert to `String`.

### matchesObjectContext

public boolean matchesObjectContext()
Description copied from class: `JSType`
This predicate is used to test whether a given type can appear in an `Object` context, such as the expression in a with statement. Most types we will encounter, except notably `null`, have at least the potential for converting to `Object`. Host defined objects can get peculiar.

### removeProperty

public boolean removeProperty(String name)
Description copied from class: `ObjectType`
Removes the declared or inferred property from this ObjectType.

Overrides:
  `removeProperty` in class `ObjectType`
Parameters:
  `name` - the property's name
Returns:
  true if the property was removed successfully. False if the property did not exist, or could not be removed.

### setPropertyJSDocInfo

public void setPropertyJSDocInfo(String propertyName, JSDocInfo info)
Description copied from class: `ObjectType`
Sets the docInfo for the specified property from the `JSDocInfo` on its definition.

Overrides:
  `setPropertyJSDocInfo` in class `ObjectType`
Parameters:
  `info` - `JSDocInfo` for the property definition. May be `null`.

### unboxesTo

public JSType unboxesTo()
Description copied from class: `JSType`
Turn an object type to its corresponding scalar type.

Overrides:
  `unboxesTo` in class `JSType`
Returns:
  the unboxed type or `null` if this type does not unbox.

### canBeCalled

public boolean canBeCalled()
Description copied from class: `JSType`
This predicate is used to test whether a given type can be used as the 'function' in a function call.

Overrides:
  `canBeCalled` in class `JSType`
Returns:
  `true` if this type might be callable.

### getReferenceName

public String getReferenceName()
Description copied from class: `ObjectType`
Gets the reference name for this object. This includes named types like constructors, prototypes, and enums. It notably does not include literal types like strings and booleans and structural types.

Specified by:
  `getReferenceName` in class `ObjectType`
Returns:
  the object's name or `null` if this is an anonymous object

### hasReferenceName

public boolean hasReferenceName()
Description copied from class: `ObjectType`
Returns true if the object is named.

Overrides:
  `hasReferenceName` in class `ObjectType`
Returns:
  true if the object is named, false if it is anonymous

### hasCachedValues

public boolean hasCachedValues()
Description copied from class: `ObjectType`
Returns true if any cached values have been set for this type. If true, then the prototype chain should not be changed, as it might invalidate the cached values.

Overrides:
  `hasCachedValues` in class `ObjectType`

### isNativeObjectType

public boolean isNativeObjectType()
Whether this is a built-in object.

Overrides:
  `isNativeObjectType` in class `ObjectType`

### getOwnerFunction

public FunctionType getOwnerFunction()
Description copied from class: `ObjectType`
Gets the owner of this if it's a function prototype.

Overrides:
  `getOwnerFunction` in class `ObjectType`

### getCtorImplementedInterfaces

public Iterable<ObjectType> getCtorImplementedInterfaces()
Description copied from class: `ObjectType`
Gets the interfaces implemented by the ctor associated with this type. Intended to be overridden by subclasses.

Overrides:
  `getCtorImplementedInterfaces` in class `ObjectType`

### getCtorExtendedInterfaces

public Iterable<ObjectType> getCtorExtendedInterfaces()
Description copied from class: `ObjectType`
Gets the interfaces extended by the interface associated with this type. Intended to be overridden by subclasses.

Overrides:
  `getCtorExtendedInterfaces` in class `ObjectType`

### matchConstraint

public void matchConstraint(JSType constraint)
Description copied from class: `JSType`
Modify this type so that it matches the specified type. This is useful for reverse type-inference, where we want to infer that an object literal matches its constraint (much like how the java compiler does reverse-inference to figure out generics).

Overrides:
  `matchConstraint` in class `JSType`
Parameters:
  `constraint` -

### matchRecordTypeConstraint

public void matchRecordTypeConstraint(ObjectType constraintObj)